SETKEY(8)

NAME
setkey - manually manipulate the SA/SP database.

SYNOPSIS
setkey [-dv] -c
setkey [-dv] -f filename
setkey [-adPlv] -D
setkey [-dPv] -F
setkey [-h] -x

DESCRIPTION
setkey updates, or lists the content of, Security Association Database (SAD) entries in the kernel as well as Security Policy Database (SPD) entries.

setkey takes a series of operation from standard input ( if invoked with -c) or file named filename ( if invoked with -f filename).

-D  Dump the SAD entries. If with -P, the SPD entries are dumped.

-F  Flush the SAD. If with -P, the SPD are flushed.

-a  setkey usually do not display dead SAD entries on -D. With -a, dead SAD entries will be displayed as well. Dead SAD entries are kept in the kernel, when they are referenced from any of SPD entries in the kernel.

-d  Enable debugging messages.

-x  Loop forever and dump all the messages transmitted to PF_KEY socket.

-h  Add hexadecimal dump on -x mode. The order is significant.

-l  Loop forever with short output on -D.

-v  Be verbose. PF_KEY socket ( including messages sent from other processes).

Operation has the following grammar. Note that lines, that start with a hashmark ('#') are treated as comment lines. Description of meta-arguments follows.

    add src dst protocol spi [extensions] algorithm...; Add a SAD entry.

    get src dst protocol spi [mode]; Show a SAD entry.

    delete src dst protocol spi [mode]; Remove a SAD entry.

    flush [protocol]; Clear all SAD entries that matches the options.

    dump [protocol]; Dumps all SAD entries that matches the options.

    spdadd src_range dst_range upperspec policy; Add a SPD entry.

    spddelete src_range dst_range upperspec; Delete a SPD entry.

    spdflush; Clear all SPD entries.

    spddump; Dumps all SPD entries.

Meta-arguments are as follows:
src
dst Source/destination of the secure communication is specified as IPv4/v6 address. setkey does not consult hostname-to-address for arguments src and dst. They must be in numeric form.

protocol
    protocol is one of following:
    esp ESP based on rfc2405
    esp-old
        ESP based on rfc1827
    ah  AH based on rfc2402
    ah-old
        AH based on rfc1826
    ipcomp
        IPCOMP

spi Security Parameter Index (SPI) for the SA and SPD. It must be decimal number or hexadecimal number ( with 0x attached).

extensions
    takes some of the following:
    -m mode
        Specify an security protocol mode for use. By default, any. mode is one of following: transport, tunnel or any.
    -r size
        Specify window size of bytes for replay prevention. size must be decimal number in 32-bit word. If size is zero or not specified, replay check don't take place.
    -f pad_option
        pad_option is one of following: zero-pad, random-pad or seq-pad
    -f cyclic-seq
        Allow cyclic sequence number.
    -lh time
    -ls time
        Specify hard/soft lifetime.

algorithm
    -E ealgo key
        Specify encryption algorithm.
    -A aalgo key
        Specify authentication algorithm. If -A is used for esp, it will be treated as ESP payload authentication algorithm.
    -C calgo [-R]
        Specify compression algorithm. If -R is specified with ipcomp line, the kernel will use well-known IPComp CPI (compression parameter index) on IPComp CPI field on packets, and spi field will be ignored. spi field is only for kernel internal use in this case. If -R is not used, the value on spi field will appear on IPComp CPI field on outgoing packets. spi field needs to be smaller than 0x10000 in this case.

    esp SAs accept -E and -A. esp-old SAs accept -E only. ah and ah-old SAs accept -A only. ipcomp SAs accept -C only.

    key must be double-quoted character string or a series of hexadecimal digits.

    Possible values for ealgo, aalgo and calgo are specified in separate section.
src_range
dst_range
    These are selection of the secure communication is specified as IPv4/v6 address or IPv4/v6 address range, and it may accompany TCP/UDP port specification. This takes the following form:

        address
        address/prefixlen
        address[port]
        address/prefixlen[port]

    prefixlen and port must be decimal number. The square bracket around port is really necessary. They are not manpage metacharacters.

    setkey does not consult hostname-to-address for arguments src and dst. They must be in numeric form.
upperspec
    Upper-layer protocol to be used. Currently tcp, udp and any can be specified. any stands for “any protocol”.

    NOTE: upperspec does not work against forwarding case at this moment, as it requires extra reassembly at forwarding node (not implemented as this moment).
policy
    policy is the one of following:

        -P
        direction
        discard

        -P
        direction
        none

        -P
        direction
        ipsec
        protocol/mode/src-dst/level

    You must specify the direction of its policy as direction. Either out or in are used. discard means the packet matching indexes will be discarded. none means that IPsec operation will not take place onto the packet. ipsec means that IPsec operation will take place onto the packet. Either ah, esp or ipcomp is to be set as protocol. mode is either transport or tunnel. You must specify the end-points addresses of the SA as src and dst with ‘-’ between these addresses which is used to specify the SA to use. level is to be one of the following: default, use or require. default means kernel consults to the system wide default against protocol you specified, e.g. esp_trans_deflev sysctl variable, when kernel processes the packet. use means that kernel use a SA if it's available, otherwise kernel keeps normal operation. require means SA is required whenever kernel deals with the packet. Note that “discard” and “none” are not in the syntax described in ipsec_set_policy(3). There are little differences in the syntax. See ipsec_set_policy(3) for detail.

ALGORITHMS
The following list shows the supported algorithms. protocol and algorithm are almost orthogonal. Following are the list of authentication algorithms that can be used as aalgo in -A aalgo of protocol parameter:

    algorithm	keylen (bits)	comment
    hmac-md5	128		ah: rfc2403
    		128		ah-old: rfc2085
    hmac-sha1	160		ah: rfc2404
    		160		ah-old: 128bit ICV (no document)
    keyed-md5	128		ah: 96bit ICV (no document)
    		128		ah-old: rfc1828
    keyed-sha1	160		ah: 96bit ICV (no document)
    		160		ah-old: 128bit ICV (no document)
    null		0 to 2048	for debugging

Following are the list of encryption algorithms that can be used as ealgo in -E ealgo of protocol parameter:

    algorithm	keylen (bits)	comment
    des-cbc		64		esp-old: rfc1829, esp: rfc2405
    3des-cbc	192		rfc2451
    simple		0 to 2048	rfc2410
    blowfish-cbc	40 to 448	rfc2451
    cast128-cbc	40 to 128	rfc2451
    rc5-cbc		40 to 2040	rfc2451
    des-deriv	64		ipsec-ciph-des-derived-01 (expired)
    3des-deriv	192		no document

Following are the list of compression algorithms that can be used as calgo in -C calgo of protocol parameter:

    algorithm	comment
    deflate		rfc2394
    lzs		rfc2395

EXAMPLES

    add	3ffe:501:4819::1 3ffe:501:481d::1 esp 123457
    		-E des-cbc "ESP SA!!" ;
    add	3ffe:501:4819::1 3ffe:501:481d::1 ah 123456
    		-A hmac-sha1 "AH SA configuration!" ;
    add	10.0.11.41 10.0.11.33 esp 0x10001
    		-E des-cbc "ESP with"
    		-A hmac-md5 "authentication!!" ;
    get	3ffe:501:4819::1 3ffe:501:481d::1 ah 123456 ;
    flush ;
    dump esp ;
    spdadd	10.0.11.41/32[21] 10.0.11.33/32[any] any
    		-P out ipsec esp/tunnel/192.168.0.1-192.168.1.2/require ;

RETURN VALUES
The command exits with 0 on success, and non-zero on errors.

SEE ALSO
ipsec_set_policy(3), sysctl(8)

HISTORY
The setkey command first appeared in WIDE Hydrangea IPv6 protocol stack kit. The command was completely re-designed in June 1998.

IPv6 and IPsec support based on the KAME Project (http://www.kame.net/) stack was initially integrated into FreeBSD 4.0